/*
 * Temperature Converter Sample C# language version
 * 
 * Copyright 2002~2003 Marco Savegnago msave@tin.it
 * 
 */

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text;

namespace TemperatureConverter
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class FormTempConverter 
	: 
		System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label labelCelsius;
		private System.Windows.Forms.Label labelFahrenheight;
		private System.Windows.Forms.TextBox editCelsius;
		private System.Windows.Forms.TextBox editFahrenheight;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public FormTempConverter()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}

			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.labelCelsius = new System.Windows.Forms.Label();
			this.labelFahrenheight = new System.Windows.Forms.Label();
			this.editCelsius = new System.Windows.Forms.TextBox();
			this.editFahrenheight = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// labelCelsius
			// 
			this.labelCelsius.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelCelsius.Location = new System.Drawing.Point(8, 16);
			this.labelCelsius.Name = "labelCelsius";
			this.labelCelsius.Size = new System.Drawing.Size(48, 16);
			this.labelCelsius.TabIndex = 0;
			this.labelCelsius.Text = "Celsius";
			// 
			// labelFahrenheight
			// 
			this.labelFahrenheight.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelFahrenheight.Location = new System.Drawing.Point(8, 72);
			this.labelFahrenheight.Name = "labelFahrenheight";
			this.labelFahrenheight.Size = new System.Drawing.Size(80, 16);
			this.labelFahrenheight.TabIndex = 1;
			this.labelFahrenheight.Text = "Fahrenheight";
			// 
			// editCelsius
			// 
			this.editCelsius.Location = new System.Drawing.Point(9, 40);
			this.editCelsius.Name = "editCelsius";
			this.editCelsius.Size = new System.Drawing.Size(207, 20);
			this.editCelsius.TabIndex = 2;
			this.editCelsius.Text = "";
			this.editCelsius.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.cbcheck_KeyPress);
			this.editCelsius.TextChanged += new System.EventHandler(this.cbCelsius_TextChanged);
			this.editCelsius.Enter += new System.EventHandler(this.cbCelsius_Enter);
			// 
			// editFahrenheight
			// 
			this.editFahrenheight.Location = new System.Drawing.Point(8, 96);
			this.editFahrenheight.Name = "editFahrenheight";
			this.editFahrenheight.Size = new System.Drawing.Size(208, 20);
			this.editFahrenheight.TabIndex = 3;
			this.editFahrenheight.Text = "";
			this.editFahrenheight.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.cbcheck_KeyPress);
			this.editFahrenheight.TextChanged += new System.EventHandler(this.cbFahrenheight_TextChanged);
			this.editFahrenheight.Enter += new System.EventHandler(this.cbFahrenheight_Enter);
			// 
			// FormTempConverter
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(226, 128);
			this.Controls.Add(this.editFahrenheight);
			this.Controls.Add(this.editCelsius);
			this.Controls.Add(this.labelFahrenheight);
			this.Controls.Add(this.labelCelsius);
			this.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "FormTempConverter";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = ".NET Temperature Converter in C#";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>

		private void cbCelsius_TextChanged(object sender, System.EventArgs e)
		{
			// Clear string in another textbox if there are non here
			if (editCelsius.Text.Length <= 0 || (editCelsius.Text.Length == 1 && editCelsius.Text.Equals('-')))
				editFahrenheight.Text = "";
			// Textbox is not empty
			else
			{
				// If another control is simulating the text change,
				// then do not proceed with the text conversion for this control
				if (editCelsius.Focused == false)
					return;

				// To hold our converted single precision float value
			
				float	fDegree	= 0;

				try
				{
					// Convert text string to unsigned integer
					fDegree = checked((float)System.Convert.ToSingle(editCelsius.Text));
					fDegree = (fDegree * 9/5) + 32;
				}

				catch (System.OverflowException /*exception*/) 
				{
					// Show overflow message and return
					editFahrenheight.Text = "Overflow";
					return;
				}

				catch (System.FormatException /* exception */)
				{
					editFahrenheight.Text = "Format";
					return;
			
				}

				// Format unsigned integer value to hex and show in another textbox
				editFahrenheight.Text = fDegree.ToString();
			}
		}

		private void cbFahrenheight_TextChanged(object sender, System.EventArgs e)
		{
			// Clear string in another textbox if there are non here
			if (editFahrenheight.Text.Length <= 0 || (editFahrenheight.Text.Length == 1 && editFahrenheight.Text.Equals('-')))
				editCelsius.Text = "";

			// Textbox is not empty
			else
			{
				// If another control is simulating the text change,
				// then do not proceed with the text conversion for this control
				if (editFahrenheight.Focused == false)
					return;

				// To hold our converted single precision float value
				float fDegree = 0;

				try
				{
					// Convert hex string to unsigned integer
					fDegree = checked((float)System.Convert.ToSingle(editFahrenheight.Text));
					fDegree	= (fDegree - 32) * 5 / 9;
				}
				
				catch (System.OverflowException /*exception*/) 
				{
					// Show overflow message and return
					editCelsius.Text = "Overflow";
					return;
				}

				catch (System.FormatException /* exception */)
				{
					editCelsius.Text = "Format";
					return;
				}
				
				// Format it and show as a string
				editCelsius.Text = fDegree.ToString();
			}
		}

		private void cbcheck_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			// Process only digits and backspace

			e.Handled = true;
			
			if (Char.IsDigit(e.KeyChar) == true)
				e.Handled = false;

			switch(e.KeyChar)
			{
				case	'\b':
				case	'-':
				case	'.':
					e.Handled = false;
					break;
				default:
					break;
			}
		}

		private void cbCelsius_Enter(object sender, System.EventArgs e)
		{
			// Check if we have an "Overflow" message here, remove it
			// when we have a focus cos we are not and should not be
			// handling alphabets here.
			if (editCelsius.Text == "Overflow")
				editCelsius.Text = "";

			if (editCelsius.Text == "Format")
				editCelsius.Text = "";
		}

		private void cbFahrenheight_Enter(object sender, System.EventArgs e)
		{
			// Check if we have an "Overflow" message here, remove it
			// when we have a focus cos we are not and should not be
			// handling alphabets other than 'a' to 'f' here.
			if (editFahrenheight.Text == "Overflow")
				editFahrenheight.Text = "";

			if (editFahrenheight.Text == "Format")
				editFahrenheight.Text = "";
		}
	}
}
